# Getestet mit Python 3.11.6 und PySide 6.5.3

import sys
import random
import time
import math
import locale
import PySide6.QtWidgets as widgets
import PySide6.QtUiTools as uic

# Viele rote Kringel, weil die Typen erst bekannt sind, wenn der QUiLoader gelaufen ist.
# Man könnte mit typing.cast abhelfen, aber das wird unübersichtlich.

d : list[tuple[float, float, float]] = []  # ": list[tuple[float, float, float]]" gegen die Typen-Warnungskringel

t1 = time.perf_counter()
xm1 = -1.0
ym1 = -1.0
xm2 = -1.0
ym2 = -1.0
s = -1.0
first = True

def click():
    t2 = time.perf_counter()
    global first, t1, xm1, ym1, xm2, ym2, s
    if not first:
        d.append((s, math.sqrt((xm2-xm1)**2 + (ym2-ym1)**2), t2-t1))
    first = False
    t1 = t2
    xm1 = xm2
    ym1 = ym2
    verschiebe()

def verschiebe():
    global xm2, ym2, s
    s = random.randint(15, 100)
    w.pushButton.setFixedHeight(s)
    w.pushButton.setFixedWidth(s)
    x = random.randint(0, w.centralwidget.width() - s - 1)
    y = random.randint(0, w.centralwidget.height() - s - 1)
    w.pushButton.move(x, y)
    xm2 = x + 0.5*s
    ym2 = y + 0.5*s
    
app = widgets.QApplication(sys.argv)
w = uic.QUiLoader().load("fitts.ui")
w.statusBar().hide()
w.pushButton.clicked.connect(click)
w.show()
verschiebe()
app.exec()

locale.setlocale(locale.LC_ALL, "")
f = open('fitts.csv', 'w')
for v in d:
    f.write(locale.str(v[0])+';'+locale.str(v[1])+';'+locale.str(v[2])+"\n")
f.close()

sys.exit(0)